/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef FLATVIEW_H
#define FLATVIEW_H

#include "view.h"

#include <qwidget.h>
#include <qimage.h>

class Game;

class FlatView: public QWidget, public View {
Q_OBJECT public:
    FlatView(QWidget * parent , Game *);
    virtual ~FlatView();
    void print(QPrinter * pPrinter);

protected slots:
    void frame();

protected:
    CoorFloat screen2board(QPoint);
    QPoint board2screen(CoorFloat);
    int selection(QPoint);
    void paintEvent(QPaintEvent *);
    void resizeEvent(QResizeEvent *);

//    void mouseMoveEvent(QMouseEvent * e);
//    void resize(int w, int h);
    QPixmap pixmap[13];
    QPixmap bufferPM, boardPM, chessPiecesPM, boardWithNonMovingPM;
    QImage image[13], chessPieces;
    QTimer *frameTimer;
    void mousePressEvent(QMouseEvent *e);
    void mouseMoveEvent(QMouseEvent *e);
signals:
    void enterEvent(QEvent *);
    void leaveEvent(QEvent *);
};

#endif
