/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "listview.h"
#include "game.h"

#include <qtextedit.h>
#include <qlineedit.h>
#include <qlayout.h>

#include <kaction.h>

ListView::ListView(QWidget *parent, Game *g)
 : QWidget(parent)
{
    game = g;
    setCaption(game->gameMoves.tagPairs["White"] + " vs " + game->gameMoves.tagPairs["Black"]);
    QVBoxLayout *vbox = new QVBoxLayout(this);
    vbox->addWidget(lb = new QTextEdit(this));
    lb->setReadOnly(true);
    lb->setTextFormat(RichText);
//    lb->setWordWrap(QTextEdit::NoWrap);
    vbox->addWidget(le = new QLineEdit(this));
}

ListView::~ListView() {
}

void ListView::setMoveList(Pgn *list) {
    QString s = "<qt>White: "+list->tagPairs["White"] + "<br>";
    s += "Black: "+list->tagPairs["Black"] + "<br>";
    int m=2;
    int pos = s.length() - 12;
    for (MoveTree *i = list; i->moves.count(); i = i->moves.first().nextMove, m++) {
	if (i == list->getCurrent())
	    s += "<font color=""grey"">";
	if (!(m&1)) {
            s += "<nobr>" + QString::number(m/2)+". </nobr>";
	    pos += QString::number(m/2).length() + 2;
	}
	movePos[m-2] = pos;
	s += i->moves.first().san+" ";
	pos += i->moves.first().san.length() + 1;
    }
    movePos[m-2] = pos;
    movePos[m-1] = 2000000000;
    s += "</qt>";
    lb->setText(s);
}

#include "listview.moc"
