/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include "main.h"
#include "debug.h"

#ifdef MYDEBUG

FILE *debuglog;
/*
unsigned long long timepool[NUM_PROFILES + 1];
unsigned long long calls[NUM_PROFILES + 1];
unsigned long long prof_calls[NUM_PROFILES + 1];
int *timestack;
*/
void debug(const char *s, ...) 
{
    va_list ap;
    va_start(ap, s);
    if (flags.debug & DEBUG_TOLOGFILE) {
        vfprintf(debuglog, s, ap);
    }
    if (flags.debug & DEBUG_TOSTDERR)
        vfprintf(stderr, s, ap);
    va_end(ap);
}
/*
void initProfiler()
{
    for (int i = 0; i <= NUM_PROFILES; i++) {
        calls[i] = 0;
        timepool[i] = 0;
    }
    timestack = malloc(PROFILE_NESTING_LEVEL * sizeof(int));
    *timestack = 0;
    timepool[*timestack] -= rdtsc();
}

int cmp(int *a, int *b) {
    if (timepool[*a] > timepool[*b]) return -1;
    if (timepool[*a] < timepool[*b]) return 1;
    return 0;
}
    
void exitProfiler()
{
    const char *profname[] = { "TIME_UNKNOWN",
                                "TIME_SEARCH",
                                "TIME_SEARCHQ",
                                "TIME_MOVEGEN",
                                "TIME_MOVEGENQ",
                                "TIME_SORT",
                                "TIME_DOMOVE",
                                "TIME_UNDOMOVE",
                                "TIME_EMPTY",
                                "TIME_HASHRD",
                                "TIME_HASHWR",
                                "TIME_PREHASH",
                                "TIME_MOVEORD",
                                "TIME_DYNEVAL",
                                "TIME_SORTQ",
                                "TIME_SQLP",
                                "TIME_CALLING",
                                "TIME_ICHECK",
                                "TIME_ICHECKS" };

    BEGIN_PROFILE(TIME_CALLING);
    for (unsigned i = 0; i < 0x1000; i++) {
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
        BEGIN_PROFILE(TIME_EMPTY);
        END_PROFILE();
    }
    END_PROFILE();
    
    timepool[*timestack] += rdtsc();
    
    double t0 = (double)timepool[TIME_CALLING] / 0x8000;
    double t1 = (double)timepool[TIME_EMPTY] / 0x8000;      //time between start of BEGIN_PROFILE an start of END_PROFILE
    printf("calling time is %5.2f clocks\n", t0);
    printf("null time is %5.2f clocks\n", t1);
    calls[0] = 1;
    
    for (unsigned i = 0; i < NUM_PROFILES; i++) 
        timepool[i] -= calls[i] * t1 + prof_calls[i] * t0;

    unsigned long long total = 0;
    for (unsigned i = 0; i < NUM_PROFILES; i++) 
        if (calls[i]) 
            total += timepool[i];
            
    int index[100]; for (int i=0; i<100; i++) index[i] = i;
    qsort(index, NUM_PROFILES, sizeof(int), cmp);
            
    for (unsigned i = 0; i < NUM_PROFILES; i++) 
        if (calls[index[i]]) 
            printf("%9.3f s (%6.3f%%) in %13s,%11lld calls, %6.1f clocks per call\n", timepool[index[i]] / (1e6 * cpuclock), timepool[index[i]]*100.0/total, profname[index[i]], calls[index[i]], timepool[index[i]] / (calls[index[i]] + 0.1));

#if 0               
extern u_short profileBuf[];

    for (int i=0; i<5000; i++)
        if(profileBuf[i])
            printf("search + %4x: %5d\n", i*4, profileBuf[i]); 
#endif            
}
*/
#endif
