/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef DEBUG_H
#define DEBUG_H

#include <stdio.h>

#define TIME_SEARCH 1
#define TIME_SEARCHQ 2
#define TIME_MOVEGEN 3
#define TIME_MOVEGENQ 4
#define TIME_SORT 5
#define TIME_DOMOVE 6
#define TIME_UNDOMOVE 7
#define TIME_EMPTY 8
#define TIME_HASHREAD 9
#define TIME_HASHWRITE 10
#define TIME_PREHASH 11
#define TIME_MOVEORD 12
#define TIME_DYNEVAL 13
#define TIME_QSORT 14
#define TIME_SEARCHQLOOP 15
#define TIME_CALLING 16
#define TIME_INCHECK 17
#define TIME_INCHECKSIG 18

#ifdef MYDEBUG

#define DEBUG_TOLOGFILE 1
#define DEBUG_TOSTDERR 2
#define DEBUG_MOVES 4
#define DEBUG_INTEGRITY 8
#define DEBUG_IO 16
#define DEBUG_INFO 32
#define DEBUG_SEARCH 64

extern FILE *debuglog;

/*profile macros are no longer necessary, since oprofile does the job better.

#define NUM_PROFILES 20
#define PROFILE_NESTING_LEVEL 1000

extern unsigned long long timepool[NUM_PROFILES + 1];
extern unsigned long long calls[NUM_PROFILES + 1];
extern unsigned long long prof_calls[NUM_PROFILES + 1];
extern int *timestack;

inline static unsigned long long rdtsc()
{
    unsigned long long ret;
    asm volatile ("rdtsc":"=A" (ret));
    return ret;
}
*/
#define BEGIN_PROFILE(x) 
/*    {\
        unsigned long long tmp = rdtsc(); \
        timepool[*timestack] += tmp; \
        prof_calls[*timestack]++;\
        timepool[x] -= tmp;\
        calls[x]++;\
        *++timestack=x;\
    }
*/
#define END_PROFILE() 
/*{ \
        unsigned long long tmp = rdtsc(); \
        timepool[*timestack] += tmp; \
        timepool[*--timestack] -= tmp; \
    }
*/
void debug(const char *s, ...) __attribute__ ((format(printf, 1, 2)));
//void initProfiler();
//void exitProfiler();
#define initProfiler()
#define exitProfiler()
#else
#define debug(x,...)
#define BEGIN_PROFILE(x) {;}
#define END_PROFILE() {;}
#define initProfiler()
#define exitProfiler()
#endif

#endif
