/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef HASHFUNC_H
#define HASHFUNC_H

#include "hash.h"
#include "debug.h"
#include "main.h"
#include "util.h"
#include <math.h>

static inline MainEntry *readHash(const Board * b)
{
    BEGIN_PROFILE(TIME_HASHREAD);
    mainHash.read++;
    MainEntry *p = CURR_HASH_PTR;
    if (p->key1 == b->key.main.key1) {
        if (p->bound == PERM_VALUE)
	    permHash.hit++;
	else
	    mainHash.hit++;
        END_PROFILE();
        return p;
    } else {
        p++;
        if (p->key1 == b->key.main.key1) { 
            stats.hit2++;
            END_PROFILE();
            return p;
        }
    }
    END_PROFILE();
    return 0;
}

static inline MainEntry *preHash(Board *b, Move *m)
{
    int piece = BOARD22(m->src)->all >> (16 + 9);
    int cap = BOARD22(m->dst)->all >> (16 + 9);
    union u64 preKey;
    preKey.key = b->key.main.key ^ HASHKEY(piece, m->src).main.key 
        ^ HASHKEY(piece, m->dst).main.key ^ HASHKEY(cap, m->dst).main.key;
    MainEntry *p = HASH_PTR(preKey, -b->color);
    if (p->key1 == b->key.main.key1)
        return p;
    else {
        p++;
        if (p->key1 == b->key.main.key1)
            return p;
    }
    return 0;
}
#endif
