%assign		col	4               ; = sizeof(int), for the x-index in value[type][y][x]
%assign		row	16*4            ; = sizeof(int[16], for the y-index
%assign		VTYPE	8*row           ; = sizeof(int[8][16], for the type-index
%assign         ATYPE   16*row          ; = sizeof(int[16][16], for the type-index in attacks[type][16][16]
%assign         COLORI  8*ATYPE         ; = sizeof(int[8][16][16], for attackVec[color][8][16][16]

%assign         piecelsize 64

%assign		ROOK	1
%assign		BISHOP	2
%assign		QUEEN	3
%assign		KNIGHT	4
%assign		PAWN	5
%assign		KING	6

%assign         PROMOQ  0x1000000
%assign         PROMON  0x2000000
%assign         PROMOB  0x3000000
%assign         PROMOR  0xb000000       ;PROMOR must be ROOKM | something
%assign         PAWNEP  0x5000000
%assign         CASTLEQ 0x6000000
%assign         CASTLEK 0x7000000
%assign         PAWNDBL 0x9000000
%assign         ROOKM   0x8000000
%assign         KINGM   0xa000000

%assign         CAST_WQ 0x1             ;castling flags
%assign         CAST_WK 0x2
%assign         CAST_BQ 0x4           
%assign         CAST_BK 0x8

extern          board
extern          values
extern          attacks
extern          attackVec
extern          attackBy
extern          pieces
extern          epstatus
extern          o_o
extern          color
extern          value
extern          hashKeys
extern          mainHashKey
extern          pawnHashKey
extern          glmove

%define		Board           board  + 2*row + 2*col	;board = &Board::board[2][2]
%define		Value	        values + 6*VTYPE		;value = &Board::value[6][0][0]
%define		Attacks	        attacks +6*ATYPE + 2*row + 2*col
%define         AttackVec       attackVec + 2*row + 2*col + COLORI
%define         AttackBy        attackBy + 2*row + 2*col
%define		Pieces	        pieces +6*piecelsize		;pieces = Board::pieces[6][0]
%define         Epstatus        epstatus
%define         O_O             o_o
%define         Color           color

%macro if 1

    %push if
    j%-1  %$ifnot

%endmacro

%macro else 0

  %ifctx if
        %repl   else
        jmp     %$ifend
        %$ifnot:
  %else
        %error  "expected `if' before `else'"
  %endif

%endmacro

%macro endif 0

  %ifctx if
        %$ifnot:
        %pop
  %elifctx      else
        %$ifend:
        %pop
  %else
        %error  "expected `if' or `else' before `endif'"
  %endif

%endmacro

%macro repeat 0 

    %push   repeat 
    %$begin: 

%endmacro 

%macro until 1 

    %ifctx repeat
        j%-1    %$begin
	%pop
    %else
	%error  "expected `repeat' before `until'"
    %endif 
%endmacro
