/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MAIN_H
#define MAIN_H

#include <ncurses.h>
#include "globals.h"
#include "board.h"

extern bool computerTurn;
extern bool pondering;          //if searchm is pondering atm
extern bool pondermode;         //wether it is allowed to ponder
extern volatile bool stopSearch;
extern int initMoves[3];
extern long long initTime[3];
extern int timeRunning;
extern unsigned cpuclock;
extern Move mList[MAXMOVES];
extern Move *eList;
extern Move returnMove, ponderMove;

extern WINDOW *lineWnd, *statWnd, *boardWnd, *inputWnd, *nodeWnd, *moveWnd;

void initTC(void);
void setTC(void);
void stop(void);
void start(void);
bool stopped(void);
void unPonder(void);
void output(const char *s, ...) __attribute__ ((format(printf, 1, 2)));
void inputMove(const char *s);

enum Mode { Force, Analyze, Normal, Autoplay, Bench };
struct Flags {
    unsigned debug;
    bool xboard;
    bool post;
    bool nobook;
    bool noeg;
    bool log;
    unsigned long long minPos;
};
extern struct Flags flags;
extern enum Mode mode;

extern int numThreads;
#endif
