CPU             P2
%define         SSE     0

%include        "macros.asm"

extern          castlingValue
extern          castlingLValue
extern          Attack
;******************************************************************************
;               searches a stripe in direction %1. %2 and %3 are 'a' and 1 for white and 'b' and '-1' for black
;               startsquare in ecx, type-offset piece in ebp, Value of Board without piece in st0
;               moves are written to [edi]

%macro          movestrip       4               ;offset, Color, piecetype, special
                movsx           edx,word[ebp+ecx+Board+1+%1-%2]	;content of next square
                cmp             edx,0
                jnz             %%endstrip      ;square occupied by same Color|border
                lea             ebx,[ecx + %1]	;next square position
%%loop:         fld             st0             ;push Value without piece
                mov             [edi+8],ecx     ;store src pos in movelist
                mov             [edi+12],ebx	;store dst pos
                fadd            dword[ebp+ebx + Value + %3*%2*VTYPE];add Value of piece in new pos
                movsx           edx,word[ebp+ebx+Board+1-%2+%1]	;content of next square
                lea             ebx,[ebx + %1]	;move pointer to new square
                fstp            dword[edi]
                cmp             edx,0
                mov             dword[edi+4],%3+%4  ;store special and piecetype
                lea             edi,[edi+16]
                jz              %%loop          ;square already occupied by white
%%endstrip:
%endmacro

;******************************************************************************
;               searches one ssquare in direction %1. %2 and %3 are 'a' and 1 for white and 'b' and '-1' for black
;               startsquare in ecx, type-offset piece in ebp, Value of Board without piece in st0
;               moves are written to [edi]

%macro          movesquare      4               ;offset
                movsx           edx,word[ebp+ecx+Board+%1+1-%2]	;content of next square
                cmp             edx,0
                jnz             %%endsquare     ;square occupied by same Color|border
                lea             ebx,[ecx + %1]  ;next square position
                fld             st0             ;push Value without piece
                mov             [edi+8],ecx     ;store src pos in movelist
                mov             [edi+12],ebx    ;store dst pos
                fadd            dword[ebp+ebx + %3*%2 * VTYPE + Value];add Value of piece in new pos
                fstp            dword[edi]
                mov             dword[edi+4],%3+%4
                lea             edi,[edi+16]
%%endsquare:
%endmacro

;******************************************************************************

%macro	        movesquarek     4               ;offset
                movsx           edx,word[ecx+AttackBy+%1+1+%2]  ;test attack square of opposite color
                cmp             edx,0
                jnz             %%endsquare
                movesquare      %1,%2,%3,%4
%%endsquare:
%endmacro
;******************************************************************************

%macro          movegen_m       1
                push            ebp
                push            edi
                push            esi
                push            edx
                push            ecx
                push            ebx

                mov             edi,[esp + 28]	;movelist
                mov             ebp,[esp + 32]
                fld             dword[value]	;general Value of posistion

                xor             eax,eax
                add             eax,[ebp + Pieces+ROOK*piecelsize*%1];	;piececount
                jz              %%endrook

%%rooklp:       mov             ecx,[ebp + Pieces+eax*4+ROOK*piecelsize*%1]	;pointer to square occupied by piece
                fld             st0
 		        fsub            dword [ebp+ecx+Value+ROOK*VTYPE*%1]	;sub Value of piece
 		movestrip	col,%1,ROOK,ROOKM
 		movestrip	row,%1,ROOK,ROOKM
 		movestrip	-col,%1,ROOK,ROOKM
 		movestrip	-row,%1,ROOK,ROOKM
		fstp            st0
        	dec		eax
		jnz		%%rooklp
%%endrook:

                add             eax,[ebp+Pieces+BISHOP*piecelsize*%1];	;pi
		jz		%%endbishop
%%bishoplp:     mov             ecx,[ebp+Pieces+eax*4+BISHOP*piecelsize*%1]	;po
		fld		st0
                fsub            dword [ebp+ecx+Value+BISHOP*VTYPE*%1]	;sub Value of piece
		movestrip	col+row,%1,BISHOP,0
		movestrip	col-row,%1,BISHOP,0
		movestrip	-col+row,%1,BISHOP,0
		movestrip	-col-row,%1,BISHOP,0
		fstp            st0
        	dec		eax
		jnz		%%bishoplp
%%endbishop:

                add             eax,[ebp+Pieces+QUEEN*piecelsize*%1];	;piececount
		jz		%%endqueen
%%queenlp:      mov             ecx,[ebp+Pieces+eax*4+QUEEN*piecelsize*%1]	;po
		fld		st0
                fsub            dword [ebp+ecx+Value+QUEEN*VTYPE*%1]	;sub Value of piece
 		movestrip	col,%1,QUEEN,0
 		movestrip	row,%1,QUEEN,0
 		movestrip	-col,%1,QUEEN,0
 		movestrip	-row,%1,QUEEN,0
		movestrip	col+row,%1,QUEEN,0
		movestrip	col-row,%1,QUEEN,0
		movestrip	-col+row,%1,QUEEN,0
		movestrip	-col-row,%1,QUEEN,0
		fstp            st0
                dec		eax
		jnz		%%queenlp
%%endqueen:

                add             eax,[ebp+Pieces+KNIGHT*piecelsize*%1];	;pi
                jz              %%endknight
%%knightlp:     mov             ecx,[ebp+Pieces+eax*4+KNIGHT*piecelsize*%1]	;po
                fld             st0
                fsub            dword [ebp+ecx+Value+KNIGHT*VTYPE*%1]	;sub Value of piece
                movesquare      col+col+row,%1,KNIGHT,0
                movesquare      col+col-row,%1,KNIGHT,0
                movesquare      -col-col+row,%1,KNIGHT,0
                movesquare      -col-col-row,%1,KNIGHT,0
                movesquare      col+row+row,%1,KNIGHT,0
                movesquare      col-row-row,%1,KNIGHT,0
                movesquare      -col+row+row,%1,KNIGHT,0
                movesquare      -col-row-row,%1,KNIGHT,0
                fstp            st0
                dec             eax
                jnz             %%knightlp
%%endknight:


                add             eax,[ebp+Pieces+PAWN*piecelsize*%1];	;piececount
                jz              %%endpawn                               ;no pawns there
%%pawnlp:       mov             ecx,[ebp+Pieces+eax*4+PAWN*piecelsize*%1]	;position of pawn
                fld             st0
                fsub            dword[ebp+ecx+Value+PAWN*VTYPE*%1]	        ;sub Value of ppawn at startposition
;single step forward
                movsx           edx,word[ebp+ecx+Board+row*%1]	        ;content of
                cmp             edx,0
                jnz             %%pawn0		;square occupied|border
                lea             ebx,[ecx+row*%1]	;next square positi
                fld             st0		;push Value without piece
                mov             [edi+8],ecx	;store src pos in movelist
                fadd            dword[ebp+ebx + Value+PAWN*VTYPE*%1];add Value of piece
                mov             [edi+12],ebx	;store dst pos
                fstp		dword[edi]
                mov             dword[edi+4],PAWN;ebp

		lea		edi,[edi+16]
;2 step forward
%ifidn		%1,1
                cmp             ecx,2*row		;PAWN at second row?
		jae		%%pawn1
%else
                cmp		ecx,6*row
		jb		%%pawn1
%endif
                movsx           edx,word[ebp+ecx+Board+2*row*%1]	;content of
	    	cmp		edx,0
    		jnz		%%pawn0		;square occupied|border
;                mov             ebp,[ecx + Attacks + %1*PAWN*ATYPE + 2*row*%1]
;                or              ebp,PAWN + PAWNDBL
	    	lea		ebx,[ecx+2*row*%1]	;next square positi
    		fld		st0		;push Value without piece
	    	mov		[edi+8],ecx	;store src pos in movelist
    		mov		[edi+12],ebx	;store dst pos
	    	    fadd            dword[ebp+ebx + Value+PAWN*VTYPE*%1];add Value of piece
    		fstp		dword[edi]
                mov             dword[edi+4],PAWN+PAWNDBL
	    	lea		edi,[edi+16]
                jmp             %%pawn0

%%promo:  
                fld             st0
                fadd            dword[ebp+ ebx + Value+KNIGHT*VTYPE*%1];add Value of piece
                fsub            dword[ebp+ edx + Value]
                fstp            dword[edi]
                mov             dword[edi+4],PROMON + PAWN
                mov             [edi+8],ecx
                mov             [edi+12],ebx

                fld             st0
                fadd            dword[ebp+ ebx + Value+ROOK*VTYPE*%1];add Value of piece
                fsub            dword[ebp+ edx + Value]
                fstp            dword[edi+16]
                mov             dword[edi+20],PROMOR + PAWN 
                mov             [edi+24],ecx
                mov             [edi+28],ebx

                fld             st0
                fadd            dword[ebp+ ebx + Value+BISHOP*VTYPE*%1];add Value of piece
                fsub            dword[ebp+ edx + Value]
                fstp            dword[edi-16]
                mov             dword[edi-12],PROMOB + PAWN
                mov             [edi-8],ecx
                mov             [edi-4],ebx
                lea             edi,[edi+32]
                ret
%%pawn1:
%ifidn          %1,1
                cmp             ecx,6*row
                jb              %%pawn0
%else
                cmp             ecx,2*row
                jae             %%pawn0
%endif
                xor             edx,edx         ;clear destination type for non-capturing promotion
                call            %%promo
                
                movsx           edx,word[ebp+ecx+Board+1-%1+row*%1 + col]	;content of
                cmp             edx,0
%ifidn          %1,1
                jge		%%pawnr		;square occupied|border
%else
                jle		%%pawnr
%endif
                lea             ebx,[ecx+row*%1+4]	;next square positi
        		lea             edi,[edi+16]
                call            %%promo

%%pawnr:        movsx           edx,word[ebp+ecx+Board+1-%1+row*%1-4]	;content of
                cmp             edx,0
%ifidn          %1,1
                jge             %%pawnl		;square occupied|border
%else
                jle             %%pawnl
%endif
                lea             ebx,[ecx+row*%1-4]	;next square positi
                lea         edi,[edi+16]
                call            %%promo
%%pawnl:
%%pawn0:
                fstp            st0
%%nextpawn:     dec             eax 
                jnz             %%pawnlp
%%endpawn: 
                add             eax,[ebp+Epstatus]
                jz              %%KING
                cmp             word[ebp+eax+Board], -%1*PAWN*VTYPE
                jnz             %%noep2
                cmp             word[ebp+eax+Board+col], %1*PAWN*VTYPE
                jnz             %%noep1
                lea             ecx,[eax + col]
                lea             ebx,[eax + %1*row]
                fld             st0
                mov             [edi+8],ecx
                mov             [edi+12],ebx
                fsub            dword[ebp+ecx + %1*PAWN*VTYPE + Value]
                fadd            dword[ebp+ebx + %1*PAWN*VTYPE + Value]
                fsub            dword[ebp+eax - %1*PAWN*VTYPE + Value]
                fstp            dword[edi]
                mov             dword[edi+4],PAWNEP+PAWN
                lea             edi,[edi+16]

%%noep1:        cmp             word[ebp+eax+Board-col], %1*PAWN*VTYPE
                jnz             %%noep2
                lea             ecx,[ebp+eax - col]
%%ep2:          lea             ebx,[ebp+eax + %1*row]
                fld             st0
                mov             [edi+8],ecx
                mov             [edi+12],ebx
                fsub            dword[ebp+ecx + %1*PAWN*VTYPE + Value]
                fadd            dword[ebp+ebx + %1*PAWN*VTYPE + Value]
                fsub            dword[ebp+eax - %1*PAWN*VTYPE + Value]
                fstp            dword[edi]
                mov             dword[edi+4],PAWNEP + PAWN
                lea             edi,[edi+16]

%%noep2:        xor             eax,eax

%%KING:         
                cmp             eax,[ebp+Pieces+KING*piecelsize*%1]
                jz              %%endk
                
                mov             ecx,[ebp+Pieces+4+KING*piecelsize*%1]	;pos

                fsub            dword[ebp+ecx+Value+KING*VTYPE*%1]	;sub Value of piece

                test            byte[ebp+O_O], CAST_WQ << (1-%1)
                je              %%nocastleq
                cmp             [ebp+ecx + Board - 4],eax
                jne             %%nocastleq
                cmp             [ebp+ecx + Board - 8],eax
                jne             %%nocastleq
                cmp             [ebp+ecx + Board - 12],eax
                jne             %%nocastleq
                cmp             word[ebp+ecx + Board - 16],ROOK*VTYPE*%1
                jne             %%nocastleq
                cmp             [ebp+ecx + Attack + 1 + %1],ax
                jne             %%nocastlek
                cmp             [ebp+ecx + Attack - 3 + %1],ax
                jne             %%nocastleq
                cmp             [ebp+ecx + Attack - 7 + %1],ax
                jne             %%nocastleq
                lea             ebx,[ecx-8]
                fld             st0
                fadd            dword[ebp+castlingValue+%1*8+8]
                fadd            dword[ebp+ecx+Value+KING*VTYPE*%1-8]
                fsub            dword[ebp+ecx+Value+ROOK*VTYPE*%1-16]
                fadd            dword[ebp+ecx+Value+ROOK*VTYPE*%1-4]
                fstp            dword[edi]
                mov             dword[edi+4],KING+CASTLEQ
                mov             [edi+8],ecx
                mov             [edi+12],ebx
                add             edi,16
%%nocastleq:
                test            byte[ebp+O_O], CAST_WK << (1-%1)
                je              %%nocastlek
                cmp             [ebp+ecx + Board + 4],eax
                jne             %%nocastlek
                cmp             [ebp+ecx + Board + 8],eax
                jne             %%nocastlek
                cmp             word[ebp+ecx + Board + 12],ROOK*VTYPE*%1
                jne             %%nocastlek
                cmp             [ebp+ecx + AttackBy + 1 + %1],ax
                jne             %%nocastlek
                cmp             [ebp+ecx + AttackBy + 5 + %1],ax
                jne             %%nocastlek
                cmp             [ebp+ecx + AttackBy + 9 + %1],ax
                jne             %%nocastlek
                lea             ebx,[ecx+8]
                fld             st0
                fadd            dword[ebp+castlingValue+%1*8+12]
                fadd            dword[ebp+ecx+Value+KING*VTYPE*%1+8]
                fsub            dword[ebp+ecx+Value+ROOK*VTYPE*%1+12]
                fadd            dword[ebp+ecx+Value+ROOK*VTYPE*%1+4]
                fstp            dword[edi]
                mov             dword[edi+4],KING+CASTLEK
                mov             [edi+8],ecx
                mov             [edi+12],ebx
                add             edi,16
%%nocastlek:    fsub            dword[ebp+castlingLValue+%1*4+4]
                movesquarek	col,%1,KING,KINGM
                movesquarek	row,%1,KING,KINGM
                movesquarek	-col,%1,KING,KINGM
                movesquarek	-row,%1,KING,KINGM
                movesquarek	col+row,%1,KING,KINGM
                movesquarek	col-row,%1,KING,KINGM
                movesquarek	-col+row,%1,KING,KINGM
                movesquarek	-col-row,%1,KING,KINGM
%%endk:         fstp            st0
                mov             eax,edi			;return pointer
                pop             ebx
                pop             ecx
                pop             edx
                pop             esi
                pop             edi
                pop             ebp
                ret


%endmacro      ;movegen_m

;******************************************************************************
;               searches a stripe in direction %1. %2 and %3 are 'a' and 1 for white and 'b' and '-1' for black
;               startsquare in ecx, type-offset piece in ebp, Value of Board without piece in st0
;               moves are written to [edi]

%macro          movestripq      4		;offset, condition, Color, piecetype
                movsx           edx,word[ecx+Board+1+%1-%3]	;content of next square
                cmp             edx,0
                j%+2            %%endstrip	;square occupied by same Color|border
                lea             ebx,[ecx + %1]	;next square position
                jnz             %%captured	;piece not captured
%%loop:         movsx           edx,word[ebx+Board+1-%3+%1]	;content of next square
                lea             ebx,[ebx + %1]	;move pointer to new square
                cmp             edx,0
                jz              %%loop
                j%+2            %%endstrip		;square already occupied by white

%%captured:     fld             st0
                mov             dword[edi+4],0
                fadd            dword[ebx + Value + %3*%4*VTYPE];add Value of piece in new pos
                mov             [edi+8],ecx	;store src pos in movelist
                fsub            dword[ebx + edx + Value] ;subtract Value of captured
                mov             [edi+12],ebx	;store dst pos
                fstp            dword[edi]
                lea             edi,[edi+16]

%%endstrip:
%endmacro

;******************************************************************************
;               searches one ssquare in direction %1. %2 and %3 are 'a' and 1 for white and 'b' and '-1' for black
;               startsquare in ecx, type-offset piece in ebp, Value of Board without piece in st0
;               moves are written to [edi]

%macro	        movesquareq	4	;offset
 		movsx		edx,word[ecx+Board+%1+1-%3]	;content of next square
		cmp             edx,0
		j%+2		%%endsquare	;square occupied by same Color|border
		lea		ebx,[ecx + %1]	;next square position
		fld		st0		;push Value without piece
                mov             dword[edi+4],0
		mov		[edi+8],ecx	;store src pos in movelist
		mov		[edi+12],ebx	;store dst pos
		fadd		dword[ebx + %3*%4 * VTYPE + Value];add Value of piece in new pos
		fsub		dword[ebx + edx + Value] ;subtract Value of captured
		fstp		dword[edi]
		lea		edi,[edi+16]
%%endsquare:
%endmacro

;******************************************************************************

%macro		movegenq_m 3
 		push		ebp
 		push		edi
 		push		esi
 		push		edx
 		push		ecx
 		push		ebx

 		mov		edi,[esp + 28]	;movelist
 		fld		dword[value]	;general Value of posistion

 		xor		eax,eax
 		add		eax,[Pieces+ROOK*piecelsize*%1];	;piececount
 		jz		%%endrook
%%rooklp:	mov		ecx,[Pieces+eax*4+ROOK*piecelsize*%1]	;pointer to square occupied by piece

 		fld		st0
 		fsub		dword [ecx+Value+ROOK*VTYPE*%1]	;sub Value of piece
 		movestripq	col,%2,%1,ROOK
 		movestripq	row,%2,%1,ROOK
 		movestripq	-col,%2,%1,ROOK
 		movestripq	-row,%2,%1,ROOK
		fstp            st0
%%nextrook:	dec		eax
		jnz		%%rooklp
%%endrook:

		add		eax,[Pieces+BISHOP*piecelsize*%1];	;pi
		jz		%%endbishop
%%bishoplp:	mov		ecx,[Pieces+eax*4+BISHOP*piecelsize*%1]	;po

		fld		st0
		fsub		dword [ecx+Value+BISHOP*VTYPE*%1]	;sub Value of piece
		movestripq	col+row,%2,%1,BISHOP
		movestripq	col-row,%2,%1,BISHOP
		movestripq	-col+row,%2,%1,BISHOP
		movestripq	-col-row,%2,%1,BISHOP
		fstp    st0
%%nextbishop:	dec		eax
		jnz		%%bishoplp
%%endbishop:

		add		eax,[Pieces+QUEEN*piecelsize*%1];	;piececount
		jz		%%endqueen
%%queenlp:	mov		ecx,[Pieces+eax*4+QUEEN*piecelsize*%1]	;po

		fld		st0
		fsub		dword [ecx+Value+QUEEN*VTYPE*%1]	;sub Value of piece
 		movestripq	col,%2,%1,QUEEN
 		movestripq	row,%2,%1,QUEEN
 		movestripq	-col,%2,%1,QUEEN
 		movestripq	-row,%2,%1,QUEEN
		movestripq	col+row,%2,%1,QUEEN
		movestripq	col-row,%2,%1,QUEEN
		movestripq	-col+row,%2,%1,QUEEN
		movestripq	-col-row,%2,%1,QUEEN
		fstp    st0
%%nextqueen:	dec		eax
		jnz		%%queenlp
%%endqueen:

		add		eax,[Pieces+KNIGHT*piecelsize*%1];	;pi
		jz		%%endknight
%%knightlp:	mov		ecx,[Pieces+eax*4+KNIGHT*piecelsize*%1]	;po

		fld		st0
		fsub		dword [ecx+Value+KNIGHT*VTYPE*%1]	;sub Value of piece
		movesquareq	col+col+row,%3,%1,KNIGHT
		movesquareq	col+col-row,%3,%1,KNIGHT
		movesquareq	-col-col+row,%3,%1,KNIGHT
		movesquareq	-col-col-row,%3,%1,KNIGHT
		movesquareq	col+row+row,%3,%1,KNIGHT
		movesquareq	col-row-row,%3,%1,KNIGHT
		movesquareq	-col+row+row,%3,%1,KNIGHT
		movesquareq	-col-row-row,%3,%1,KNIGHT
		fstp    st0
%%nextknight:	dec		eax
		jnz		%%knightlp
%%endknight:

    		add             eax,[Pieces+PAWN*piecelsize*%1];	;piececount
		jz		%%endpawn
%%pawnlp:	mov		ecx,[Pieces+eax*4+PAWN*piecelsize*%1]	;po

		fld	        st0
		fsub		dword [ecx+Value+PAWN*VTYPE*%1]	;sub Value of piece

%ifidn		%1,1
                cmp             ecx,6*row
                jb              %%pawn0
%else
                cmp             ecx,2*row
                jae             %%pawn0
%endif
                mov             edx,[Board+ecx+row*%1]
                cmp             edx,0
                jnz             %%pawn0
                lea             ebx,[ecx+row*%1]	;next square positi
    		mov             [edi+8],ecx	;store src pos in movelist
    		mov             [edi+12],ebx	;store dst pos
                lea             edi,[edi+16]
                push            %%pawn0

%%promo:        fld             st0		;push Value without piece
    		fadd		dword[ebx + Value+QUEEN*VTYPE*%1];add Value of piece
	    	fsub		dword[ebx + edx + Value]
                fstp            dword[edi-16]

                mov             ebp,PROMOQ
                mov             [edi-12],ebp

                fld             st0
    		fadd		dword[ebx + Value+KNIGHT*VTYPE*%1];add Value of piece
	    	fsub		dword[ebx + edx + Value]
		fstp		dword[edi]
                mov             ebp,PROMON
                mov             [edi+4],ebp
                mov             [edi+8],ecx
                mov             [edi+12],ebx

                fld             st0
    		fadd		dword[ebx + Value+ROOK*VTYPE*%1];add Value of piece
	    	fsub		dword[ebx + edx + Value]
		fstp		dword[edi+16]
                mov             ebp,PROMOR
                mov             [edi+20],ebp
                mov             [edi+24],ecx
                mov             [edi+28],ebx

                fld             st0
    		fadd		dword[ebx + Value+BISHOP*VTYPE*%1];add Value of piece
	    	fsub		dword[ebx + edx + Value]
		fstp		dword[edi+32]
                mov             ebp,PROMOB
                mov             [edi+36],ebp
                mov             [edi+40],ecx
                mov             [edi+44],ebx
                lea             edi,[edi+48]

                ret


%%pawn0:        movsx		edx,word[ecx+Board+1-%1+row*%1 + col]	;content of
    		cmp		edx,0
%ifidn		%1,1
	    	jge		%%pawnr		;square occupied|border
%else
                jle		%%pawnr
%endif
    		lea		ebx,[ecx+row*%1+4]	;next square positi
	    	fld		st0		;push Value without piece
                mov             dword[edi+4],0
        	mov		[edi+8],ecx	;store src pos in movelist
    		mov		[edi+12],ebx	;store dst pos
    		fadd		dword[ebx + Value+PAWN*VTYPE*%1];add Value of piece
	    	fsub		dword[ebx + edx + Value]
		fstp		dword[edi]
    		lea		edi,[edi+16]
%ifidn		%1,1
                cmp             ecx,6*row
                jb              %%pawnr
%else
                cmp             ecx,2*row
                jae             %%pawnr
%endif
                call            %%promo
                
%%pawnr:	movsx		edx,word[ecx+Board+1-%1+row*%1-4]	;content of
	    	cmp		edx,0
%ifidn		%1,1
    		jge		%%pawnl		;square occupied|border
%else
		jle		%%pawnl
%endif
    		lea		ebx,[ecx+row*%1-4]	;next square positi
	    	fld		st0		;push Value without piece
                mov             dword[edi+4],0
    		mov		[edi+8],ecx	;store src pos in movelist
	    	mov		[edi+12],ebx	;store dst pos
    		fadd		dword[ebx + Value+PAWN*VTYPE*%1];add Value of piece
	    	fsub		dword[ebx + edx + Value]
    		fstp		dword[edi]
	    	lea		edi,[edi+16]
%ifidn		%1,1
                cmp             ecx,6*row
                jb              %%pawnl
%else
                cmp             ecx,2*row
                jae             %%pawnl
%endif
                call            %%promo
%%pawnl:
    		fstp            st0
%%nextpawn:	dec		eax
	    	jnz		%%pawnlp
%%endpawn:

%%KING:         cmp             eax,[Pieces+KING*piecelsize*%1]
                jz              %%endk
                mov		ecx,[Pieces+4+KING*piecelsize*%1]	;pos
		fsub		dword[ecx+Value+KING*VTYPE*%1]	;sub Value of piece
 		movesquareq	col,%3,%1,KING
 		movesquareq	row,%3,%1,KING
 		movesquareq	-col,%3,%1,KING
 		movesquareq	-row,%3,%1,KING
		movesquareq	col+row,%3,%1,KING
		movesquareq	col-row,%3,%1,KING
		movesquareq	-col+row,%3,%1,KING
		movesquareq	-col-row,%3,%1,KING
%%endk:         fstp        st0
		mov         eax,edi			;return pointer
		pop         ebx
		pop         ecx
		pop         edx
		pop         esi
		pop         edi
		pop         ebp
		ret


%endmacro      ;movegenq_m



                fucomi          st3
                jbe             insert_at_end
                mov             eax,[esp+36]
                lea             ecx,[eax+128]
                cmp             ecx,edi                 ;min (edi,ecx+128)
                cmova           ecx,edi                 ;ecx=

binsearch:      mov             ecx,eax
                add             ecx,ebx
                rcr             ecx,1
                and             ecx,0xfffffff0
                cmp             ecx,eax                 ;x
                fld             dword[ecx]              ;a[x]
                lea             edx,[ecx+0x10]
                lea             ecx,[ecx-0x10]
                fcomip         st1                     ;cmp    a[x],v
                je              found
                cmovb           ebx,ecx                 ;if [x]<v r=x-1
                cmova           eax,edx                 ;if a[x]>=c     l=x+1
                cmp             eax,ebx
                jbe             binsearch

found:

insert_at_end:  fstp            dword[edi]
                mov             [edi+8],ecx
                mov             [edi+12],ebx
                ret

%macro          swapp       2
                fild         qword[%1]
                fild         qword[%1+8]
                fild         qword[%2]
                fild         qword[%2+8]
                fistp        qword[%1+8]
                fistp        qword[%1]
                fistp        qword[%2+8]
                fistp        qword[%2]
%endmacro


%macro          sort_m          2
                call            %%sortrec
                popa
                ret

%%sortrec:  cmp         eax,ebp
            jae         %%nosort
            cmp         eax,ebx
            jae         %%nosort
            fld         dword[ebx];         st0:=v
            fld         dword[eax];
            fcomip      st1                 ;if (eax->val > v) {
            j%2         %%pivotok
            swapp       eax,ebx
            fstp        st0
            lea         ecx,[eax+16]            ;ecx = eax+1;
            cmp         ecx,ebx
            je          %%nosort
            mov         edx,ebx;
            fld         dword[ebx]             ;          v = ebx->val;
            jmp         %%jumpin

%%pivotok:    lea         ecx,[eax+16]
            cmp         ecx,ebx
            je          %%nosort2
            mov         ecx,eax;
            mov         edx,ebx;
            fld         dword[ecx]
            fcomip     st1
            j%-1         %%jloop           ;if (ecx->val >= v) break;

%%iloop:      lea         ecx,[ecx+16];
%%jumpin:     fld         dword[ecx]
            fcomip     st1
            j%1          %%iloop           ;if (ecx->val >= v) break;

%%jloop:      lea         edx,[edx-16];
            fld         dword[edx]
            fcomip     st1         ;while ((--edx)->val > v);
            j%-2          %%jloop
            cmp         edx,ecx     ;if (edx <= ecx) goto endlp;
            je          %%endloopnoswap
            jbe         %%endloop
            swapp       ecx,edx
            jmp         %%iloop

%%endloop:    swapp        ebx,ecx

%%endloopnoswap:
            lea         edx,[ecx-32]
            cmp         eax,edx
            fstp        st0
            jb          %%swap2_1
            lea         eax,[ecx+16]
            ja          %%swap2_2
            fld         dword[edx]
            fld         dword[ecx-16]
            fcomip     st1
            fstp        st0
            j%-1        %%swap2_2
            swapp       edx,ecx-16
            jmp         %%swap2_2

%%swap2_1:    push        ebx
            lea         ebx,[ecx-16]
            call        %%sortrec          ;sort(eax, ecx - 1);
            lea         eax,[ebx+32]    ;eax = ecx+1;
            pop         ebx

%%swap2_2:    lea         edx,[ebx-16]
            cmp         eax,edx
            jb          %%sortrec
            ja          %%swap2_3

            fld         dword[eax]
            fld         dword[ebx]
            fcomip     st1
            fstp        st0
            j%-1        %%swap2_3
            swapp       eax,ebx
%%swap2_3:    ret

%%nosort2:    fstp        st0
%%nosort:     ret

%endmacro

;******************************************************************************
;global visible definitions
;******************************************************************************
                    
global          movegen
global          movegenq
global          sort
global          inCheck

movegen:        cmp             dword[Color],-1
                je              movegen_b
                movegen_m	    1	;(move* mlist,  float Value)
movegen_b:      movegen_m       -1

movegenq:       cmp             dword[Color],-1
                je              movegenq_b
                movegenq_m	1,g,ge	;(move* mlist,  float Value)
movegenq_b:     movegenq_m       -1,l,le

sort:           pusha
                mov         eax,[esp+36]        ;param eax := l ebx := r;
                lea         ebp,[eax+32]
                mov         ebx,[esp+40]
                cmp         dword[color],0
                jg          sort_w
                sort_m          b,be
sort_w:         sort_m          a,ae

inCheck:        mov             eax,[color]
                neg             eax
                lea             eax,[eax+eax*2]
                shl             eax,7
                mov             eax,[Pieces+eax+4]
                sub             eax,[color]
                movzx           eax,word[eax + AttackBy + 1]
                ret

