/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MOVEGEN_C_H
#define MOVEGEN_C_H
//array[p][d] with a value dirtab[dir] for every distance d from a piece p,
//if p is attacking the square in distance d from direction dir, otherwise 0.
//maximum distance betwen 2 pieces is 7*(1,1), with a row = 16 columns. for negative distances too, thus 2*

extern int distTable[6][16][16];


//macro for accessing distTable with distances in the char* format.
//returns a value != 0 if piece p is attacking dst from position src, with d=dst-src
#define DIST(p,d) ( *(int *)( (char *)&distTable[p-1][8][8] + (d) ) )

Move *movegenq1(const constBoard * b, Move * m, float alpha);
Move *movegenq(const constBoard * b, Move * m, float alpha);
Move *movegen(const constBoard * b, Move * m);
#ifdef SIMPLEBOARD
int inCheck(const constBoard *b, int color);
#endif
int inCheckSig(Board *b);
void movegenqInit(void);
#endif
