#define PAWN_ATTACK     1               //2 bits, only 2 pawns of the same color can attack the same square
#define BISHOP_ATTACK   (1 << 2)        //2 bits. 4 bishops attacking the same square should be pretty scarce
#define KNIGHT_ATTACK   (1 << 4)        //3 bits. so we cant handle up to than 7 knights attacking the same square correctly. this bug was left intentionally.
#define ROOK_ATTACK     (1 << 7)        //2 bits, max 3 rooks attacking the same square
#define QUEEN_ATTACK    (1 << 9)       //3 bits
#define KING_ATTACK     (1 << 12)       //1 bit
#define BCHECK_ATTACK	(1 << 13)	//1 bit. goes from king in all diagonal directions
#define RCHECK_ATTACK	(1 << 14)	//1 bit. goes from king in all line directions
#define NCHECK_ATTACK   (1 << 15)	//1 bit. from king in all knight directions
#define CHECK_ATTACK    (DCHECK_ATTACK | LCHECK_ATTACK | NCHECK_ATTACK)
#define ATTACK_MASK (0xffff & ~CHECK_ATTACK) //everything but a check attack, to mask out the fake attacks

//writes a queen, rook, bishop, knight move into the move list. accordingly sets attackflag
inline static Move *insertQMove(const constBoard *b, Move * m, int src, int dst, int special, int piece, float val) {
    m->attack = (ATTACK22(dst)->b & (BCHECK_ATTACK | RCHECKATTACK) != 0;
    m->val = val;
    m->special = special;
    m->piece = piece;
    m->src = src;
    m->dst = dst;
    return ++m;
}

inline static Move *insertRMove(const constBoard *b, Move * m, int src, int dst, int special, int piece, float val) {
    m->attack = (ATTACK22(dst)->b & RCHECK_ATTACK ) != 0;
    m->val = val;
    m->special = special;
    m->piece = piece;
    m->src = src;
    m->dst = dst;
    return ++m;
}

inline static Move *insertBMove(const constBoard *b, Move * m, int src, int dst, int special, int piece, float val) {
    m->attack = (ATTACK22(dst)->b & BCHECK_ATTACK ) != 0;
    m->val = val;
    m->special = special;
    m->piece = piece;
    m->src = src;
    m->dst = dst;
    return ++m;
}

inline static Move *insertNMove(const constBoard *b, Move * m, int src, int dst, int special, int piece, float val) {
    m->attack = (ATTACK22(dst)->b & NCHECK_ATTACK ) != 0;
    m->val = val;
    m->special = special;
    m->piece = piece;
    m->src = src;
    m->dst = dst;
    return ++m;
}

#define attackw(blah, x) (ATTACK22(x)->w & ATTACK_MASK)
#define attackb(blah, x) (ATTACK22(x)->b & ATTACK_MASK)

#define attackwsig(blah, x, foobar) (ATTACK22(x)->w & ATTACK_MASK)
#define attackbsig(blah, x, foobar) (ATTACK22(x)->b & ATTACK_MASK) 

//internal functions for movegen
#define insertNCMove(attp, from, to) { \
    m->val = srcval + *VALUE6(attp, to); \
    m->special = 0; \
    m->src = from; \
    m->dst = to; \
    m++; \
}

#define ray(p, dir)  {\
    int dst = src;\
    for (int i = *ATTACKLEN22(dir, src); i>0; i--) {\
        dst += dirtab[dir];\
        insertNCMove(p, src, dst);\
    }\
}

#define insertMove_w(attp, from, to, p) { \
    float newval = b->currMove->move.val - *VALUE6(attp, from) + *VALUE6(attp, to) - *VALUE6(p, to); \
    if (newval <= alpha) return m; \
    m->val = newval; \
    m->special = 0; \
    m->src = from; \
    m->dst = to; \
    m++; \
}

#define insertMove_b(attp, from, to, p) { \
    float newval = b->currMove->move.val - *VALUE6(attp, from) + *VALUE6(attp, to) - *VALUE6(p, to); \
    if (newval >= -alpha) return m; \
    m->val = newval; \
    m->special = 0; \
    m->src = from; \
    m->dst = to; \
    m++; \
}

#define insertPMove_w(from, to, cap) { \
    float newval = b->currMove->move.val - *VALUE6(PAWN, from) + *VALUE6(QUEEN, to) - *VALUE6(0, to + cap); \
    if (newval <= alpha) return m; \
    m->val = newval; \
    m->special = SPEC_PROMOQ; \
    m->src = from; \
    m->dst = to; \
    m++; \
}

#define insertPMove_b(from, to, cap) { \
    float newval = b->currMove->move.val - VALUE6(-PAWN, from) + VALUE6(-QUEEN, to) - VALUE6(0, to + cap); \
    if (newval >= -alpha) return m; \
    m->val = newval; \
    m->special = SPEC_PROMOQ; \
    m->src = from; \
    m->dst = to; \
    m++; \
}

//static inline void specialw(Board *b, Move *m, unsigned atttype, int pp, int p, float alpha) {    

#define specialw(b, m, atttype, pp, p) {\
    if (atttype & PAWN_ATTACK * 3) {\
        int attpiece = atttype & PAWN_ATTACK * 3;        \
        const int *attpp;        \
        for (attpp = &POS(PAWN, CNT(PAWN) - 1); attpp > &POS(PAWN, 0); attpp--) {            \
            if (DIST(PAWN, pp - *attpp)) {                \
                if (!(attpiece -= PAWN_ATTACK))                    \
                    break;                \
                if (pp < 7 * ROW)                    \
                    insertMove_w(PAWN, *attpp, pp, p);                \
            }\
        }\
        if (pp < 7 * ROW)            \
            insertMove_w(PAWN, *attpp, pp, p);        \
    }\
    if (atttype & KNIGHT_ATTACK * 7) {        \
        int attpiece = atttype & KNIGHT_ATTACK * 7;        \
        const int *attpp;        \
        for (attpp = &POS(KNIGHT, CNT(KNIGHT) - 1); attpp > &POS(KNIGHT, 0); attpp--) {            \
            if (DIST(KNIGHT, *attpp - pp)) {                \
                if (!(attpiece -= KNIGHT_ATTACK))                    \
                    break;                \
                insertMove_w(KNIGHT, *attpp, pp, p);                \
            }\
        }\
        insertMove_w(KNIGHT, *attpp, pp, p);        \
    }\
    if (atttype & BISHOP_ATTACK * 3) {        \
        int attpiece = atttype & BISHOP_ATTACK * 7;        \
        const int *attpp;        \
        for (attpp = &POS(BISHOP, CNT(BISHOP) - 1); attpp > &POS(BISHOP, 0); attpp--) {            \
            if (DIST(BISHOP, *attpp - pp)) {                \
                int step = DIST(BISHOP, *attpp - pp);                \
                int blocked = 0;                \
                for (int between = pp + step; between != *attpp; between += step)                    \
                    if (BOARD22(between)->all) {                        \
                        blocked = 1;                        \
                        break;                        \
                    }\
                if (!blocked) {                    \
                    if (!(attpiece -= BISHOP_ATTACK))                        \
                        break;                    \
                    insertMove_w(BISHOP, *attpp, pp, p);                    \
                }\
            }\
        }\
        insertMove_w(BISHOP, *attpp, pp, p);        \
    }\
    if (atttype & ROOK_ATTACK * 3) {        \
        int attpiece = atttype & ROOK_ATTACK * 7;        \
        const int *attpp;        \
        for (attpp = &POS(ROOK, CNT(ROOK) - 1); attpp > &POS(ROOK, 0); attpp--) {            \
            if (DIST(ROOK, *attpp - pp)) {                \
                int step = DIST(ROOK, *attpp - pp);                \
                int blocked = 0;                \
                for (int between = pp + step; between != *attpp; between += step)                    \
                    if (BOARD22(between)->all) {                        \
                        blocked = 1;                        \
                        break;                        \
                    }\
                if (!blocked) {                    \
                    if (!(attpiece -= ROOK_ATTACK))                        \
                        break;                    \
                    insertMove_w(ROOK, *attpp, pp, p);                    \
                }\
            }\
        }\
        insertMove_w(ROOK, *attpp, pp, p);        \
    }\
    if (atttype & QUEEN_ATTACK * 7) {        \
        int attpiece = atttype & QUEEN_ATTACK * 7;        \
        const int *attpp;        \
        for (attpp = &POS(QUEEN, CNT(QUEEN) - 1); attpp > &POS(QUEEN, 0); attpp--) {            \
            if (DIST(QUEEN, *attpp - pp)) {                \
                int step = DIST(QUEEN, *attpp - pp);                \
		int blocked = 0;                \
                for (int between = pp + step; between != *attpp; between += step)                    \
                    if (BOARD22(between)->all) {                        \
                        blocked = 1;                        \
                        break;                        \
                    }\
                if (!blocked) {                    \
                    if (!(attpiece -= QUEEN_ATTACK))                        \
                        break;                    \
                    insertMove_w(QUEEN, *attpp, pp, p);                    \
                }\
            }\
        }\
        insertMove_w(QUEEN, *attpp, pp, p);        \
    }\
    if (atttype & KING_ATTACK)        \
        insertMove_w(KING, POS(KING, 0), pp, p);    \
}

inline static Move *movegenqw(const constBoard * b, Move * m, float alpha) {

    for (const int *ppp = &POS(PAWN, CNT(PAWN) - 1); ppp >= &POS(PAWN, 0); ppp--) {
        if (*ppp >= 6 * ROW) {  //first check for promotions.
            int pp;
            if (BOARD22(pp = *ppp + ROW + COL)->w < 0)
                insertPMove_w(*ppp, pp, BOARD22(pp)->w);
            if (BOARD22(pp = *ppp + ROW - COL)->w < 0)
                insertPMove_w(*ppp, pp, BOARD22(pp)->w);
            if (BOARD22(pp = *ppp + ROW)->b == 0)
                insertPMove_w(*ppp, pp, 0);
        }
    }

    for (const int *ppp = &POS(-QUEEN, CNT(-QUEEN) - 1); ppp >= &POS(-QUEEN, 0); ppp--) {     //piece position pointer
        int pp = *ppp;          //piece position
        if (ATTACK22(pp)->w)
            specialw(b, m, ATTACK22(pp)->w, pp, -QUEEN);
    }
    for (const int *ppp = &POS(-ROOK, CNT(-ROOK) - 1); ppp >= &POS(-ROOK, 0); ppp--) {        //piece position pointer
        int pp = *ppp;          //piece position
        if (ATTACK22(pp)->w)
            specialw(b, m, ATTACK22(pp)->w, pp, -ROOK);
    }
    for (const int *ppp = &POS(-BISHOP, CNT(-BISHOP) - 1); ppp >= &POS(-BISHOP, 0); ppp--) {  //piece position pointer
        int pp = *ppp;          //piece position
        if (ATTACK22(pp)->w)
            specialw(b, m, ATTACK22(pp)->w, pp, -BISHOP);
    }
    for (const int *ppp = &POS(-KNIGHT, CNT(-KNIGHT) - 1); ppp >= &POS(-KNIGHT, 0); ppp--) {  //piece position pointer
        int pp = *ppp;          //piece position
        if (ATTACK22(pp)->w)
            specialw(b, m, ATTACK22(pp)->w, pp, -KNIGHT);
    }
    for (const int *ppp = &POS(-PAWN, CNT(-PAWN) - 1); ppp >= &POS(-PAWN, 0); ppp--) {        //piece position pointer
        int pp = *ppp;          //piece position
        if (ATTACK22(pp)->w)
            specialw(b, m, ATTACK22(pp)->w, pp, -PAWN);
    }
    return m;
}


//non-capture move generator. generates the remainig moves, after movegenq was called.
static Move *movegenw(const constBoard * b, Move * m) {
    
    movegenqw(b, m, -INF);
    //pawn moves
    for (const int *ppp = &POS(PAWN, CNT(PAWN) - 1); ppp >= &POS(PAWN, 0); ppp--) {   //piece position pointer
        int src = *ppp;
        float srcval = b->currMove->move.val - *VALUE6(PAWN, src);
        //generate underpromotions. queening is already done by movegenq.
        if (src >= 6 * ROW) {
            int dst;
            if (BOARD22(dst = src + dirtab[1])->w < 0) {
                m = insertMove(m, src, dst, SPEC_PROMOQ, PAWN, srcval + *VALUE6(QUEEN, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
                m = insertMove(m, src, dst, SPEC_PROMOR, PAWN, srcval + *VALUE6(ROOK, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
                m = insertMove(m, src, dst, SPEC_PROMON, PAWN, srcval + *VALUE6(KNIGHT, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
                m = insertMove(m, src, dst, SPEC_PROMOB, PAWN, srcval + *VALUE6(BISHOP, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
            }
            if (BOARD22(dst = src + dirtab[3])->w < 0) {
                m = insertMove(m, src, dst, SPEC_PROMOQ, PAWN, srcval + *VALUE6(QUEEN, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
                m = insertMove(m, src, dst, SPEC_PROMOR, PAWN, srcval + *VALUE6(ROOK, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
                m = insertMove(m, src, dst, SPEC_PROMON, PAWN, srcval + *VALUE6(KNIGHT, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
                m = insertMove(m, src, dst, SPEC_PROMOB, PAWN, srcval + *VALUE6(BISHOP, dst) - *VALUE6(0, BOARD22(dst)->w + dst));
            }
            if (BOARD22(dst = src + dirtab[2])->w == 0) {
                m = insertMove(m, src, dst, SPEC_PROMOQ, PAWN, srcval + *VALUE6(QUEEN, dst));
                m = insertMove(m, src, dst, SPEC_PROMOR, PAWN, srcval + *VALUE6(ROOK, dst));
                m = insertMove(m, src, dst, SPEC_PROMON, PAWN, srcval + *VALUE6(KNIGHT, dst));
                m = insertMove(m, src, dst, SPEC_PROMOB, PAWN, srcval + *VALUE6(BISHOP, dst));
            }
	} else {
            int dst;
            if (BOARD22(dst = src + dirtab[2])->all == 0) {
                m = insertMove(m, src, dst, 0, PAWN, srcval + *VALUE6(PAWN, dst));
                if (BOARD22(dst = src + 2 * dirtab[2])->all == 0 && src < 2 * ROW)
                    m = insertMove(m, src, dst, SPEC_PAWNDBL, PAWN, srcval + *VALUE6(PAWN, dst));
            }
	}
        //en passant capture
        if (src >= 4 * ROW && (src + dirtab[0] == b->epstatus || src + dirtab[4] == b->epstatus))
            m = insertMove(m, src, b->epstatus + dirtab[2], SPEC_PAWNEP, PAWN, srcval + *VALUE6(PAWN, b->epstatus + ROW) - *VALUE6(-PAWN, b->epstatus));
    }

    //rook moves
    for (const int *ppp = &POS(ROOK, CNT(ROOK) - 1); ppp >= &POS(ROOK, 0); ppp--) {   //piece position pointer
        int src = *ppp;
        float srcval = b->currMove->move.val - *VALUE6(ROOK, src);
        ray(ROOK, 0);
        ray(ROOK, 2);
        ray(ROOK, 4);
        ray(ROOK, 6);
    }

    //bishop moves
    for (const int *ppp = &POS(BISHOP, CNT(BISHOP) - 1); ppp >= &POS(BISHOP, 0); ppp--) {     //piece position pointer
        int src = *ppp;
        float srcval = b->currMove->move.val - *VALUE6(BISHOP, src);
        ray(BISHOP, 1);
        ray(BISHOP, 3);
        ray(BISHOP, 5);
        ray(BISHOP, 7);
    }

    //queen moves
    for (const int *ppp = &POS(QUEEN, CNT(QUEEN) - 1); ppp >= &POS(QUEEN, 0); ppp--) {        //piece position pointer
        int src = *ppp;
        float srcval = b->currMove->move.val - *VALUE6(QUEEN, src);
        ray(QUEEN, 0);
        ray(QUEEN, 2);
        ray(QUEEN, 4);
        ray(QUEEN, 6);
        ray(QUEEN, 1);
        ray(QUEEN, 3);
        ray(QUEEN, 5);
        ray(QUEEN, 7);
    }

    //knight moves
    for (const int *ppp = &POS(KNIGHT, CNT(KNIGHT) - 1); ppp >= &POS(KNIGHT, 0); ppp--) {     //piece position pointer
        int src = *ppp;
        float srcval = b->currMove->move.val - *VALUE6(KNIGHT, src);
        if (BOARD22(src + kdirtab[0])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[0]);
        if (BOARD22(src + kdirtab[1])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[1]);
        if (BOARD22(src + kdirtab[2])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[2]);
        if (BOARD22(src + kdirtab[3])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[3]);
        if (BOARD22(src + kdirtab[4])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[4]);
        if (BOARD22(src + kdirtab[5])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[5]);
        if (BOARD22(src + kdirtab[6])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[6]);
        if (BOARD22(src + kdirtab[7])->all == 0)
            insertNCMove(KNIGHT, src, src + kdirtab[7]);
    }

    //castling
    int src = POS(KING, 0);
    float srcval = b->currMove->move.val - *VALUE6(KING, src);
    if (b->o_o & CAST_WQ && ATTACK22(4 * COL)->b == 0 && ATTACK22(3 * COL)->b == 0 && ATTACK22(2 * COL)->b == 0 && *ATTACKLEN22(4, 4 * COL) == 3)
        insertMovew(b ,m, src, src - 2 * COL, SPEC_CASTLEQ, KING, srcval);
    if (b->o_o & CAST_WK && ATTACK22(4 * COL)->b == 0 && ATTACK22(5 * COL)->b == 0 && ATTACK22(6 * COL)->b == 0 && *ATTACKLEN22(0, 4 * COL) == 2)
        insertMove(m, src, src + 2 * COL, SPEC_CASTLEK, KING, srcval);

    //normal king moves
    if ((BOARD22(src + dirtab[0])->all | ATTACK22(src + dirtab[0])->b) == 0)
        insertMove(m, src, src + dirtab[0], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[1])->all | ATTACK22(src + dirtab[1])->b) == 0)
        insertMove(m, src, src + dirtab[1], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[2])->all | ATTACK22(src + dirtab[2])->b) == 0)
        insertMove(m, src, src + dirtab[2], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[3])->all | ATTACK22(src + dirtab[3])->b) == 0)
        insertMove(m, src, src + dirtab[3], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[4])->all | ATTACK22(src + dirtab[4])->b) == 0)
        insertMove(m, src, src + dirtab[4], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[5])->all | ATTACK22(src + dirtab[5])->b) == 0)
        insertMove(m, src, src + dirtab[5], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[6])->all | ATTACK22(src + dirtab[6])->b) == 0)
        insertMove(m, src, src + dirtab[6], SPEC_KING, KING, srcval);
    if ((BOARD22(src + dirtab[7])->all | ATTACK22(src + dirtab[7])->b) == 0)
        insertMove(m, src, src + dirtab[7], SPEC_KING, KING, srcval);

    return m;
}

static Move *movegenqb(const constBoard * b, Move * m, float alpha) {
    return m;
}

static Move *movegenb(const constBoard * b, Move * m) {
    return m;
}
