/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef UTIL_H
#define UTIL_H
#include "globals.h"
#include <ncurses.h>
#include <stdio.h>

extern struct Stats {
    int ply;			//current ply
    int currMoveNum;
    int moveCount;		//# of moves possible
    unsigned long long moves;		//# of moves done
    unsigned long long qMoves;		//# of moves done
    unsigned long long pos;			//# of evaluated pos
    unsigned long long qPos;		//# of evaluated quiesence pos
    unsigned long long alpha;
    unsigned long long beta;
    unsigned long long precut;
    unsigned long long BM;
    unsigned long long ret;
    unsigned long long aret;
    unsigned long long bret;
    unsigned long long hit2;
    unsigned long long shift2;
    unsigned long long write2;
    unsigned long long zz;
    unsigned long long null;
    unsigned long long nulltry;
    unsigned long long zzq;
    unsigned long long nullq;
    unsigned long long nullqtry;
    unsigned long long startTime;
    unsigned long long bTime;
    unsigned long long extHorizon;
    unsigned long long extCheck;
    unsigned long long extRecapture;
    unsigned long long extMate;
    unsigned long long extPawn;
    Move bestMove;
    float eval;	//eval fir each line
    float lastEval;
} stats;


void displayBoard(WINDOW *);
void printBoard(const Board *, FILE *);
void copyBoard(void);
int str2move(const char *s, Move * m, Move * firstMove, Move * lastMove);
const char *moveToStr(const Move * m);
void printStats(WINDOW * wnd);
void printNode(WINDOW * wnd);
void printAttackBy(void);
void postInfo(void);
void postLines(void);
void printValues(int);
void line2str(const Move *, char *s);
int importEPD(const char *s);
void upNode(void);
void downNode(void);
void leftNode(void);
void rightNode(void);
void printMoveList(void);
#endif
