/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "statview.h"
#include "slibo.h"
#include "game.h"
#include "engine.h"

#include <qtimer.h>
#include <qtextedit.h>

#include <kaction.h>

StatView::StatView(QWidget *parent, Game *g, Engine *e)
 : QTextEdit(parent)
{
    game = g;
    engine = e;
    setCaption("Analysis from " + e->nickName);
    setReadOnly(true);
    setWordWrap(QTextEdit::NoWrap);

    refresh = 2000;
    refreshTimer = new QTimer(this);
    connect(refreshTimer, SIGNAL(timeout()), SLOT(updateStats()));
    refreshTimer->start(refresh);
}


StatView::~StatView() {
}


void StatView::setRefresh(int r) {
    refresh = r;
    refreshTimer->stop();
    refreshTimer->start(refresh);
}

void StatView::updateStats() {
    if (!engine->canStat) 
	delete refreshTimer;
    else
	engine->write("stat");
}

#include "statview.moc"
