/***************************************************************************
 *   Copyright (C) 2003 by Gunther Piez                                    *
 *   gpiez@users.sourceforge.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// application specific includes
#include "slibo.h"
#include "view.h"
#include "game.h"
#include "promodialog.h"

#include <iostream>

#include <qpushbutton.h>

using namespace std;

//
//view base class, for both flat view and gl view
//
View::View() {
    picking = -1;		//no piece currently picked up
}

View::~View() {
}

bool View::leftClick(QPoint p) {

    if (picking < 0) {
        picking = selection(p);
        if (picking < 0  || picking >= 0x100) {
            picking = -1;
            return false;
        } else {
            oldpickPos = board2screen(game->visiblePieces[picking].curr);
            src = CoorInt( int(game->visiblePieces[picking].curr.x + 0.5), int(game->visiblePieces[picking].curr.y + 0.5) );
            game->visiblePieces[picking].picked = true;
            game->movingChanged = true;
            return true;
        }
    } else {
        dst = CoorInt( int (game->visiblePieces[picking].curr.x + 0.5), int (game->visiblePieces[picking].curr.y + 0.5) );
        if (dst == src) {
            game->visiblePieces[picking].picked = false;
            game->movingChanged = true;
            picking = -1;
            game->repaintAllViews();
//                bool    found=false;
            return false;
        } else {                    //piece taken bakc to old square
            qDebug("Move input: %d%d-%d%d", src.x, src.y, dst.x, dst.y);
            VMove m = VMove(-1, src, dst );
            for (VMoveList::iterator i = game->legalMoves.begin(); i != game->legalMoves.end(); i++) {
//                qDebug("%d%d-%d%d", (*i).src.x, (*i).src.y, (*i).dst.x, (*i).dst.y);
            }
            if (unsigned c = game->legalMoves.contains(m)) {
                if (c>1) {
                    qDebug("promotion %d\n", c);
                    PromoDialog *dlg = new PromoDialog();
                    dlg->exec();
                    if (dlg->knight->isDown())
                        m.special = PROMON;
                    else if (dlg->rook->isDown())
                        m.special = PROMOR;
                    else if (dlg->bishop->isDown())
                        m.special = PROMOB;
                    else
                        m.special = PROMOQ;
                    delete dlg;
                } else {
                    m = *(game->legalMoves.find(m));
                }
                game->visiblePieces[picking].picked = false;
                game->movingChanged = true;
                picking = -1;
                game->inputMove(m);
                return false;
            }
            return true;
        }
    }
}




